//SIG SG550 Assault Rifle
//Absolution: Model
//Amad: Script, icon and CI images
//Thanks to StratoFortress for script reference. (Headshot check via Z axis comparison, from the AWM Sniper Rifle.)

%error = ForceRequiredAddOn("Weapon_Gun");
if(%error == $Error::AddOn_Disabled)
{
   GunItem.uiName = "";
}
if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Weapon_SG550 - Required Add-On Weapon_Gun not found.");
}

datablock AudioProfile(SG550fireSound)
{
   fileName    = "./SG550fire.wav"; //Thanks to ClickTeam (company, not a user) for the sound.
   description = AudioClose3d;
   preload     = true;
};

AddDamageType("SG550",'<bitmap:add-ons/Weapon_SG550/CI> %1','%2 <bitmap:add-ons/Weapon_SG550/CI> %1',0.2,1);
AddDamageType("SG550head",'<bitmap:add-ons/Weapon_SG550/CI_Headshot> %1','%2 <bitmap:add-ons/Weapon_SG550/CI_Headshot> %1',0.2,1);

datablock projectileData(SG550bullet : GunProjectile)
{
   directDamage     = 35;
   directDamageType = $DamageType::SG550;
   impactImpulse    = 40;
   verticalImpulse  = 40;
   muzzleVelocity   = 200;
   velInheritFactor = 1;
   uiName           = "SG550 Bullet";
};

datablock ItemData(SG550item : GunItem)
{
   shapeFile    = "./SIG_SG550.dts";
   doColorShift = false;
   iconName     = "./icon";
   uiName       = "SG550";
   image        = SG550Image;
};

datablock ShapeBaseImageData(SG550Image : GunImage)
{
   shapeFile    = SG550item.shapeFile;
   projectile   = SG550bullet;
   doColorShift = false;

   stateSound[2]        = SG550fireSound;
   stateTimeoutValue[3] = 1;
   stateEmitterTime[3]  = 0.5;
};

function SG550Image::onMount(%this, %obj, %slot)
{
   %obj.hideNode(LHand);
   %obj.hideNode(LHook);
   %obj.playThread(2,armReadyBoth);
}

function SG550Image::onUnMount(%this, %obj, %slot)
{
   %obj.client.applyBodyParts();
   Parent::onUnmount(%this, %obj, %slot);
}

function SG550bullet::Damage(%this, %obj, %col, %fade, %pos, %normal)
{
   if(%col.getClassName() $="Player" || %col.getClassName() $="AIPlayer") //If they're some kind of player
   {
      if(getWord(%pos, 2) > getWord(%col.getWorldBoxCenter(), 2) - (3.4 * getWord(%col.getScale(),2))) //Compares Z position of collision position
      {
         %obj.client.centerPrint("\c6Nice Shot!",3);
         %obj.client.play2D(rewardSound); //Remember that sound from the tutorial?
         %this.directDamageType = $DamageType::SG550head; //Change the damageType to change the CI!
         parent::Damage(%this, %obj, %col, %fade, %pos, %normal); //Damage them
         parent::Damage(%this, %obj, %col, %fade, %pos, %normal); //Again
         parent::Damage(%this, %obj, %col, %fade, %pos, %normal); //AGAIN
         parent::Damage(%this, %obj, %col, %fade, %pos, %normal); //AGAIN!!!
         %this.directDamageType = $DamageType::SG550; //Change it back.
      }
   }
   else
   {
      parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
   }
}